=== modified file 'INSTALL'
--- INSTALL	2014-07-25 22:44:20 +0000
+++ INSTALL	2014-06-22 02:19:30 +0000
@@ -4,15 +4,14 @@
   
 ** Operating System
    
-   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat" (or later).
+   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat".
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
-   and that the initial RAM file system image file is automatically
-   made unreadable.  The server and client programs themselves *could*
-   be run in other distributions, but they *are* specific to GNU/Linux
-   systems, and are not written with portabillity to other Unixes in
-   mind.
+   and that the initrd.img file is automatically made unreadable.  The
+   server and client programs themselves *could* be run in other
+   distributions, but they *are* specific to GNU/Linux systems, and
+   are not written with portabillity to other Unixes in mind.
    
 ** Libraries
    
@@ -28,7 +27,7 @@
     + DocBook 4.5         http://www.docbook.org/
       Note: DocBook 5.0 is not compatible.
     + DocBook XSL stylesheets 1.71.0
-                         http://wiki.docbook.org/DocBookXslStylesheets
+                   http://wiki.docbook.org/topic/DocBookXslStylesheets
     
     Package names:
     docbook docbook-xsl
@@ -38,40 +37,36 @@
     "man -l mandos.8".
     
 *** Mandos Server
-    + GnuTLS 2.4          http://www.gnutls.org/
-      Note: GnuTLS 3 will only work with Python-GnuTLS 2
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.7          https://www.python.org/
-    + Python-GnuTLS 1.1.5 https://pypi.python.org/pypi/python-gnutls/
+    + Python 2.6          http://www.python.org/
+    + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + PyGObject 2.14.2    https://developer.gnome.org/pygobject/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
-    + Urwid 1.0.1         http://urwid.org/
-      (Only needed by the "mandos-monitor" tool.)
+    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Urwid 0.9.8.3       http://excess.org/urwid/
     
     Strongly recommended:
-    + fping 2.4b2-to-ipv6      http://www.fping.org/
+    + fping 2.4b2-to-ipv6 http://www.fping.com/
     + ssh-keyscan from OpenSSH http://www.openssh.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-gobject python-urwid pkg-config fping ssh-client
+    python-gobject python-urwid ssh-client
     
 *** Mandos Client
     + initramfs-tools 0.85i
-                        https://tracker.debian.org/pkg/initramfs-tools
-    + GnuTLS 2.4        http://www.gnutls.org/
-    + Avahi 0.6.16      http://www.avahi.org/
-    + GnuPG 1.4.9       https://www.gnupg.org/
-    + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/
-    + pkg-config  http://www.freedesktop.org/wiki/Software/pkg-config/
+                  http://packages.qa.debian.org/i/initramfs-tools.html
+    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
+    + Avahi 0.6.16        http://www.avahi.org/
+    + GnuPG 1.4.9         http://www.gnupg.org/
+    + GPGME 1.1.6         http://www.gnupg.org/related_software/gpgme/
     
     Strongly recommended:
-    + OpenSSH           http://www.openssh.com/
+    + OpenSSH             http://www.openssh.com/
     
     Package names:
     initramfs-tools libgnutls-dev libavahi-core-dev gnupg
-    libgpgme11-dev pkg-config ssh
+    libgpgme11-dev ssh
 
 * Installing the Mandos server
   
@@ -107,11 +102,15 @@
      and append this to the file "/etc/mandos/clients.conf" *on the
      server computer*.
   
-  4. Configure the client to use any special configuration needed for
-     your local system.  Note: This is not necessary if the server is
-     present on the same wired local network as the client.  If you do
-     make changes to /etc/mandos/plugin-runner.conf, the initrd.img
-     file must be updated, possibly using the following command:
+  4. Configure the client to use the correct network interface.  The
+     interface to use is automatically chosen at boot, and if this
+     needs to be adjusted, it will be necessary to edit
+     /etc/initramfs-tools/initramfs.conf to change the DEVICE setting
+     there.  Alternatively, the file /etc/mandos/plugin-runner.conf
+     can be edited to add a "--device" parameter for the
+     mandos-client(8) plugin.  Please note: If any of those files are
+     changed, the initrd.img file must be updated, possibly using the
+     following command:
      
 	# update-initramfs -k all -u
   
@@ -131,7 +130,7 @@
      
      After this, the client computer should be able to reboot without
      needing a password entered on the console, as long as it does not
-     take more than five minutes to reboot.
+     take more than an hour to reboot.
 
 * Further customizations
   
@@ -140,5 +139,3 @@
   If IPsec is not used and SSH is not installed, it is suggested that
   a more cryptographically secure checker program is used and
   configured, since, without IPsec, ping packets can be faked.
-
-#+STARTUP: showall

=== modified file 'Makefile'
--- Makefile	2014-07-17 03:24:57 +0000
+++ Makefile	2014-07-13 21:02:53 +0000
@@ -26,7 +26,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.7
+version=1.6.6
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== modified file 'NEWS'
--- NEWS	2014-07-17 03:24:57 +0000
+++ NEWS	2014-07-13 21:02:53 +0000
@@ -1,13 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.6.7 (2014-07-17)
-* Client
-** Bug fix: Now compatible with GPGME 1.5.0.
-** Bug fix: Fixed minor memory leaks.
-* Server
-** "mandos-monitor" now has verbose logging, toggleable with "v".
-
 Version 1.6.6 (2014-07-13)
 * Client
 ** If client host has an SSH server, "mandos-keygen --password" now

=== modified file 'common.ent'
--- common.ent	2014-07-17 03:24:57 +0000
+++ common.ent	2014-07-13 21:02:53 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.7">
+<!ENTITY version "1.6.6">

=== modified file 'debian/changelog'
--- debian/changelog	2014-07-17 03:24:57 +0000
+++ debian/changelog	2014-07-13 21:02:53 +0000
@@ -1,9 +1,3 @@
-mandos (1.6.7-1) unstable; urgency=medium
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Thu, 17 Jul 2014 05:22:45 +0200
-
 mandos (1.6.6-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2014-07-25 22:44:20 +0000
+++ debian/control	2014-07-12 12:54:13 +0000
@@ -7,8 +7,9 @@
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
 	pkg-config
-Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
-	python2.7-dbus, python2.7-avahi, python2.7-gobject
+Build-Depends-Indep: systemd, python (>=2.6), python-gnutls,
+	python-dbus, python-avahi, python-gobject,
+	python (>=2.7) | python-argparse
 Standards-Version: 3.9.5
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
@@ -16,11 +17,10 @@
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (<= 2.7), python2.7, python-gnutls,
-	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
-	python2.7-avahi, python-gobject, python2.7-gobject,
-	avahi-daemon, adduser, python-urwid, python2.7-urwid,
-	gnupg (<< 2), initscripts (>= 2.88dsf-13.3)
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
+	python-avahi, python-gobject, avahi-daemon, adduser,
+	python-urwid, python (>=2.7) | python-argparse, gnupg (<< 2),
+	initscripts (>= 2.88dsf-13.3)
 Recommends: ssh-client | fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2014-07-16 23:44:54 +0000
+++ initramfs-tools-hook	2013-10-28 08:38:47 +0000
@@ -150,17 +150,11 @@
 done
 
 # GPGME needs GnuPG
-gpg=/usr/bin/gpg
 libgpgme11_version="`dpkg-query --showformat='${Version}' --show libgpgme11`"
-if dpkg --compare-versions "$libgpgme11_version" ge 1.5.0-0.1; then
-    if [ -e /usr/bin/gpgconf ]; then
-	if [ ! -e "${DESTDIR}/usr/bin/gpgconf" ]; then
-	    copy_exec /usr/bin/gpgconf
-	fi
-	gpg="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg:[^:]*://p'`"
-    fi
-elif dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
+if dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
     gpg=/usr/bin/gpg2
+else
+    gpg=/usr/bin/gpg
 fi
 if [ ! -e "${DESTDIR}$gpg" ]; then
     copy_exec "$gpg"

=== modified file 'mandos'
--- mandos	2014-07-25 22:48:57 +0000
+++ mandos	2014-07-13 21:02:53 +0000
@@ -1,4 +1,4 @@
-#!/usr/bin/python2.7
+#!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
 # 
 # Mandos server - give out binary blobs to connecting clients.
@@ -88,7 +88,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.6.7"
+version = "1.6.6"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -2188,11 +2188,11 @@
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
-                                      token_week)))
+                                      token_week))),
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset(token_duration,) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -2774,8 +2774,8 @@
                 
                 # A list of attributes that can not be pickled
                 # + secret.
-                exclude = { "bus", "changedstate", "secret",
-                            "checker", "server_settings" }
+                exclude = set(("bus", "changedstate", "secret",
+                               "checker", "server_settings"))
                 for name, typ in (inspect.getmembers
                                   (dbus.service.Object)):
                     exclude.add(name)

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-07-24 01:35:55 +0000
+++ mandos-ctl	2014-07-13 21:02:53 +0000
@@ -26,10 +26,7 @@
 from __future__ import (division, absolute_import, print_function,
                         unicode_literals)
 
-try:
-    from future_builtins import *
-except ImportError:
-    pass
+from future_builtins import *
 
 import sys
 import argparse
@@ -42,9 +39,6 @@
 
 import dbus
 
-if sys.version_info[0] == 2:
-    str = unicode
-
 locale.setlocale(locale.LC_ALL, "")
 
 tablewords = {
@@ -72,7 +66,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.7"
+version = "1.6.6"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -157,11 +151,11 @@
     token_duration = Token(re.compile(r"P"), None,
                            frozenset((token_year, token_month,
                                       token_day, token_time,
-                                      token_week)))
+                                      token_week))),
     # Define starting values
     value = datetime.timedelta() # Value so far
     found_token = None
-    followers = frozenset((token_duration,)) # Following valid tokens
+    followers = frozenset(token_duration,) # Following valid tokens
     s = duration                # String left to parse
     # Loop until end token is found
     while found_token is not token_end:
@@ -236,7 +230,7 @@
         if keyword in ("Timeout", "Interval", "ApprovalDelay",
                        "ApprovalDuration", "ExtendedTimeout"):
             return milliseconds_to_string(value)
-        return str(value)
+        return unicode(value)
     
     # Create format string to print table rows
     format_string = " ".join("{{{key}:{width}}}".format(
@@ -316,8 +310,7 @@
     parser.add_argument("--approval-duration",
                         help="Set duration of one client approval")
     parser.add_argument("-H", "--host", help="Set host for client")
-    parser.add_argument("-s", "--secret",
-                        type=argparse.FileType(mode="rb"),
+    parser.add_argument("-s", "--secret", type=file,
                         help="Set password blob (file) for client")
     parser.add_argument("-A", "--approve", action="store_true",
                         help="Approve any current client request")
@@ -374,7 +367,7 @@
     if options.all or not options.client:
         clients = dict((bus.get_object(busname, path), properties)
                        for path, properties in
-                       mandos_clients.items())
+                       mandos_clients.iteritems())
     else:
         for name in options.client:
             for path, client in mandos_clients.iteritems():

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-07-17 03:24:57 +0000
+++ mandos-keygen	2014-07-13 21:02:53 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.7"
+VERSION="1.6.6"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2014-07-24 02:58:45 +0000
+++ mandos-monitor	2014-07-14 21:41:08 +0000
@@ -60,7 +60,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.7"
+version = "1.6.6"
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -661,8 +661,7 @@
             elif key == "window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == "ctrl l":
-                self.screen.clear()
+            elif key == "\f":  # Ctrl-L
                 self.refresh()
             elif key == "l" or key == "D":
                 self.toggle_log_display()

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-07-17 03:24:57 +0000
+++ mandos.lsm	2014-07-14 10:03:10 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.6.7
-Entered-date:	2014-07-17
+Version:	1.6.6
+Entered-date:	2014-07-13
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.7.orig.tar.gz
+		160K mandos_1.6.6.orig.tar.gz
 Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.7.orig.tar.gz
+		160K mandos_1.6.6.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2014-07-16 01:41:23 +0000
+++ plugin-runner.c	2014-06-14 23:43:07 +0000
@@ -887,14 +887,12 @@
     int plugin_fd = openat(dir_fd, direntries[i]->d_name, O_RDONLY);
     if(plugin_fd == -1){
       error(0, errno, "Could not open plugin");
-      free(direntries[i]);
       continue;
     }
     ret = (int)TEMP_FAILURE_RETRY(fstat(plugin_fd, &st));
     if(ret == -1){
       error(0, errno, "stat");
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     
@@ -909,7 +907,6 @@
 		direntries[i]->d_name);
       }
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     
@@ -917,7 +914,6 @@
     if(p == NULL){
       error(0, errno, "getplugin");
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     if(p->disabled){
@@ -926,7 +922,6 @@
 		direntries[i]->d_name);
       }
       TEMP_FAILURE_RETRY(close(plugin_fd));
-      free(direntries[i]);
       continue;
     }
     {
@@ -965,7 +960,6 @@
     if(ret == -1){
       error(0, errno, "pipe");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     if(pipefd[0] >= FD_SETSIZE){
@@ -974,7 +968,6 @@
       TEMP_FAILURE_RETRY(close(pipefd[0]));
       TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
 #ifndef O_CLOEXEC
@@ -985,7 +978,6 @@
       TEMP_FAILURE_RETRY(close(pipefd[0]));
       TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     ret = set_cloexec_flag(pipefd[1]);
@@ -994,7 +986,6 @@
       TEMP_FAILURE_RETRY(close(pipefd[0]));
       TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
 #endif	/* not O_CLOEXEC */
@@ -1005,7 +996,6 @@
     if(ret < 0){
       error(0, errno, "sigprocmask");
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     /* Starting a new process to be watched */
@@ -1020,7 +1010,6 @@
       TEMP_FAILURE_RETRY(close(pipefd[0]));
       TEMP_FAILURE_RETRY(close(pipefd[1]));
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
     if(pid == 0){
@@ -1065,10 +1054,8 @@
         error(0, errno, "sigprocmask");
       }
       exitstatus = EX_OSERR;
-      free(direntries[i]);
       goto fallback;
     }
-    free(direntries[i]);
     
     new_plugin->pid = pid;
     new_plugin->fd = pipefd[0];

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2014-07-15 23:52:00 +0000
+++ plugins.d/mandos-client.c	2014-07-12 13:13:28 +0000
@@ -240,14 +240,7 @@
   ret = clock_gettime(CLOCK_MONOTONIC, &(new_server->last_seen));
   if(ret == -1){
     perror_plus("clock_gettime");
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-    free((char *)(new_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
+    free(new_server->ip);
     free(new_server);
     return false;
   }
@@ -1076,7 +1069,6 @@
      timed out */
   
   if(quit_now){
-    avahi_s_service_resolver_free(r);
     return;
   }
   
@@ -1653,7 +1645,6 @@
       int status;
       if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
 	perror_plus("waitpid");
-	free(direntry);
 	continue;
       }
       if(WIFEXITED(status)){
@@ -1661,19 +1652,16 @@
 	  fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
 		       " with status %d\n", direntry->d_name,
 		       WEXITSTATUS(status));
-	  free(direntry);
 	  continue;
 	}
       } else if(WIFSIGNALED(status)){
 	fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
 		     " signal %d\n", direntry->d_name,
 		     WTERMSIG(status));
-	free(direntry);
 	continue;
       } else {
 	fprintf_plus(stderr, "Warning: network hook \"%s\""
 		     " crashed\n", direntry->d_name);
-	free(direntry);
 	continue;
       }
     }
@@ -1681,7 +1669,6 @@
       fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
 		   direntry->d_name);
     }
-    free(direntry);
   }
   free(direntries);
   if((int)TEMP_FAILURE_RETRY(close(hookdir_fd)) == -1){
@@ -2281,14 +2268,12 @@
 	if(ret_errno != 0){
 	  errno = ret_errno;
 	  perror_plus("argz_add");
-	  free(direntries[i]);
 	  continue;
 	}
 	if(debug){
 	  fprintf_plus(stderr, "Will use interface \"%s\"\n",
 		       direntries[i]->d_name);
 	}
-	free(direntries[i]);
       }
       free(direntries);
     } else {
@@ -2564,14 +2549,6 @@
     mc.current_server->prev->next = NULL;
     while(mc.current_server != NULL){
       server *next = mc.current_server->next;
-#ifdef __GNUC__
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wcast-qual"
-#endif
-      free((char *)(mc.current_server->ip));
-#ifdef __GNUC__
-#pragma GCC diagnostic pop
-#endif
       free(mc.current_server);
       mc.current_server = next;
     }
@@ -2646,7 +2623,6 @@
 			 " \"%s\", 0): %s\n", tempdir,
 			 direntries[i]->d_name, strerror(errno));
 	  }
-	  free(direntries[i]);
 	}
 	
 	/* need to clean even if 0 because man page doesn't specify */

